#pragma once

#include "Grid.h"
#include "Point3d.h"
#include "ScalarAttributes.h"
#include "VectorAttributes.h"
#include <vector>


class Grid;
class PointSearch;


class PointCloudSurface	: public Grid	//A point cloud consisting of a set of oriented points with optional scalar values 
{										//
public:
						PointCloudSurface(Grid& input);
						//Creates a surface by thresholding a scalar volume with a given scalar isovalue

					   ~PointCloudSurface();

int						numPoints()
						{ return points.size(); }

int						numCells()
						{ return points.size(); }
						
void					getPoint(int i,float* p)
						{  p[0] = points[i].x; p[1] = points[i].y; p[2] = points[i].z; }	

float					getPointRadius(int i)
						{  return points[i].value; }

int						getCell(int i,int* cell)
						{  cell[0] = i; return 1; }

int						findCell(float* p);

ScalarAttributes&		pointScalars()
						{  return scalars; }
						
VectorAttributes&		pointNormals()
						{  return normals; }

protected:

std::vector<Point3d>    points;			//input surface points
ScalarAttributes		scalars;
VectorAttributes		normals;		//point normals (estimated from surface points)
PointSearch*			point_search;	//spatial seach structure for point-cloud
};

					
